import { UserService } from "@/services/user.service";
import { RequestHandler } from "express";
import { plainToInstance } from 'class-transformer';
// import { SignInUserDto } from "@/dto/sign-in-user.dto";
import { RegistrationUserDto } from "@/dto/registration-user.dto";

export class UserController {
  private service: UserService;

  constructor() {
    this.service = new UserService();
  }

  signIn: RequestHandler = async (req, res): Promise<void> => {
    res.send(req.headers.authorization)    
    // try {
    //   const signInDto = plainToInstance(SignInUserDto, req.body)
    //   const user = await this.service.signIn(signInDto)
    //   res.send(user)
    // } catch (e) {
    //   res.status(401).send((e as Error).message)
    // }
  }

  registration: RequestHandler = async (req, res): Promise<void> => {
    const registrationInDto = plainToInstance(RegistrationUserDto, req.body)
    const user = await this.service.registration(registrationInDto)
    res.send(user)
  }
}
